<template>
    <section class="section">
        <div class="container is-fullwidth box">

            <h1 class="title is-4">meu carrinho</h1>

            <div class="columns" v-if="!empty">

                <div class="column is-three-quarters">

                    <article class="message" v-if="products.length">
                        <CartOverview />
                        <ShippingOptions
                            @shippingValue="getShippingValue"
                        />
                    </article>
                </div>
                <div class="column has-background-white-ter summary is-mobile">
                    <Summary
                        :cart="{
                            totalQtd: totalQtd,
                            subtotal: subtotal,
                            freteValorC: freteValorC,
                            totalCart: totalCart
                        }"
                    >
                        <template slot="submit">
                            <nuxt-link
                                :to="localePath({ name: 'checkout' })"
                                class="button is-link is-medium is-fullwidth"
                            >
                                <span class="icon is-small">
                                    <i class="fa fa-shopping-basket"></i>
                                </span>
                                <span class="has-text-weight-semibold">continuar</span>
                            </nuxt-link>
                        </template>
                        <template slot="cupom">
                            <p class="info-cupom my-4 text-sm">
                                possui cupom ou vale? você poderá
                                usá-los na etapa de pagamento.
                            </p>
                        </template>
                    </Summary>
                </div>
            </div>
            <div class="is-fullwidth" v-else>
                <div class="is-size-3 has-text-centered">seu carrinho está vazio</div>
            </div>
        </div>
    </section>
</template>

<style scoped>
    hr {
        display: block;
        height: 1px;
        border: 0;
        border-top: 1px solid #ccc;
        margin: 1em 0;
        padding: 0;
    }

</style>

<script>
import { mapGetters, mapActions } from 'vuex'
import CartOverview from '@/components/cart/CartOverview'
import ShippingOptions from '@/components/cart/ShippingOptions'
import Summary from '@/components/cart/Summary'

export default {
    transition: "intro",

    data () {
        return {
            freteValorC: '',
            apiStorage: 'http://127.0.0.1:8080/storage/',
        }
    },

    components: {
        CartOverview,
        ShippingOptions,
        Summary
    },

    mounted() {
        if (localStorage.frete){
            this.getShippingValue(localStorage.frete)
        }
    },

    watch: {

    },

    methods: {
        getShippingValue(value){
            this.freteValor = value
        },

        ...mapActions({
            setTotalItem: 'cart/setTotalItem'
        })

    },

    computed: {
        ...mapGetters({
            empty: 'cart/empty',
            products: 'cart/products',
            subtotal: 'cart/subtotal',
            total: 'cart/total',
            shipping: 'cart/shipping',
            changed: 'cart/changed',
            totalItem: 'cart/totalItemCart'
        }),
        redirect() {
            if (!this.$auth.loggedIn){
                return { name: 'auth-login' }
            } else {
                return { name: 'checkout' }
            }
        },
        totalQtd(){
            // let sum = 0;
            let total = this.products.reduce((totalItem, product) => {
                return totalItem + product.quantity;
            }, 0);

            this.setTotalItem(total);

            return total;
        },


        freteValor: {
            get() {
                return localStorage.frete ? localStorage.frete : 0
            },
            set(value) {
                this.freteValorC = value ? this.$currencyFormatted(value.replace(',', '.')) : ''
            }
        },

        totalCart(){
            let valCart = this.$getAmountValue(this.total)

            let totalGeral = (!this.shipping && this.freteValorC)
                            ? parseFloat(valCart) + parseFloat(this.$getAmountValue(this.freteValorC))
                            : this.total

            return !this.freteValorC ? totalGeral : this.$currencyFormatted(totalGeral);
        }

    }
}
</script>
